package github.nisrulz.projectpackagehunter;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;

class RVItemClickListener implements RecyclerView.OnItemTouchListener {
  private final OnItemClickListener mListener;

  public interface OnItemClickListener {
    void onItemClick(View view, int position);
  }

  private final GestureDetector mGestureDetector;

  public RVItemClickListener(Context context, OnItemClickListener listener) {
    mListener = listener;
    mGestureDetector = new GestureDetector(context, new GestureDetector.SimpleOnGestureListener() {
      @Override public boolean onSingleTapUp(MotionEvent e) {
        return true;
      }
    });
  }

  @Override public boolean onInterceptTouchEvent(RecyclerView view, MotionEvent e) {
    View childView = view.findChildViewUnder(e.getX(), e.getY());
    if (childView != null && mListener != null && mGestureDetector.onTouchEvent(e)) {
      mListener.onItemClick(childView, view.getChildAdapterPosition(childView));
      return true;
    }
    return false;
  }

  @Override public void onTouchEvent(RecyclerView view, MotionEvent motionEvent) {
  }

  @Override public void onRequestDisallowInterceptTouchEvent(boolean disallowIntercept) {
  }
}